Paho Asynchronous MQTT C Client Library: MQTTAsync_connectOptions Struct Reference

| Paho Asynchronous MQTT C Client Library

Loading...
Searching...
No Matches
Data Fields
MQTTAsync_connectOptions Struct Reference

`#include <MQTTAsync.h>`

## Data Fields
char | struct_id [4]
int | struct_version
int | keepAliveInterval
int | cleansession
int | maxInflight
MQTTAsync_willOptions * | will
const char * | username
const char * | password
int | connectTimeout
int | retryInterval
MQTTAsync_SSLOptions * | ssl
MQTTAsync_onSuccess * | onSuccess
MQTTAsync_onFailure * | onFailure
void * | context
int | serverURIcount
char *const * | serverURIs
int | MQTTVersion
int | automaticReconnect
int | minRetryInterval
int | maxRetryInterval
struct { |
int len |
const void * data |
} | binarypwd
int | cleanstart
MQTTProperties * | connectProperties
MQTTProperties * | willProperties
MQTTAsync_onSuccess5 * | onSuccess5
MQTTAsync_onFailure5 * | onFailure5
const MQTTAsync_nameValue * | httpHeaders
const char * | httpProxy
const char * | httpsProxy

## Detailed Description

MQTTAsync_connectOptions defines several settings that control the way the client connects to an MQTT server.

Suitable default values are set in the following initializers:

- MQTTAsync_connectOptions_initializer: for MQTT 3.1.1 non-WebSockets
- MQTTAsync_connectOptions_initializer5: for MQTT 5.0 non-WebSockets
- MQTTAsync_connectOptions_initializer_ws: for MQTT 3.1.1 WebSockets
- MQTTAsync_connectOptions_initializer5_ws: for MQTT 5.0 WebSockets

## Field Documentation

## ◆ struct_id

char struct_id[4]

The eyecatcher for this structure. must be MQTC.

## ◆ struct_version

int struct_version

The version number of this structure. Must be 0, 1, 2, 3 4 5 6, 7 or 8. 0 signifies no SSL options and no serverURIs 1 signifies no serverURIs 2 signifies no MQTTVersion 3 signifies no automatic reconnect options 4 signifies no binary password option (just string) 5 signifies no MQTTV5 properties 6 signifies no HTTP headers option 7 signifies no HTTP proxy and HTTPS proxy options

## ◆ keepAliveInterval

int keepAliveInterval

The "keep alive" interval, measured in seconds, defines the maximum time that should pass without communication between the client and the server The client will ensure that at least one message travels across the network within each keep alive period. In the absence of a data-related message during the time period, the client sends a very small MQTT "ping" message, which the server will acknowledge. The keep alive interval enables the client to detect when the server is no longer available without having to wait for the long TCP/IP timeout. Set to 0 if you do not want any keep alive processing.

## ◆ cleansession

int cleansession

This is a boolean value. The cleansession setting controls the behaviour of both the client and the server at connection and disconnection time. The client and server both maintain session state information. This information is used to ensure "at least once" and "exactly once" delivery, and "exactly once" receipt of messages. Session state also includes subscriptions created by an MQTT client. You can choose to maintain or discard state information between sessions.

When cleansession is true, the state information is discarded at connect and disconnect. Setting cleansession to false keeps the state information. When you connect an MQTT client application with MQTTAsync_connect(), the client identifies the connection using the client identifier and the address of the server. The server checks whether session information for this client has been saved from a previous connection to the server. If a previous session still exists, and cleansession=true, then the previous session information at the client and server is cleared. If cleansession=false, the previous session is resumed. If no previous session exists, a new session is started.

## ◆ maxInflight

int maxInflight

This controls how many messages can be in-flight simultaneously.

## ◆ will

MQTTAsync_willOptions* will

This is a pointer to an MQTTAsync_willOptions structure. If your application does not make use of the Last Will and Testament feature, set this pointer to NULL.

## ◆ username

const char* username

MQTT servers that support the MQTT v3.1 protocol provide authentication and authorisation by user name and password. This is the user name parameter.

## ◆ password

const char* password

MQTT servers that support the MQTT v3.1 protocol provide authentication and authorisation by user name and password. This is the password parameter.

## ◆ connectTimeout

int connectTimeout

The time interval in seconds to allow a connect to complete.

## ◆ retryInterval

int retryInterval

The time interval in seconds after which unacknowledged publish requests are retried during a TCP session. With MQTT 3.1.1 and later, retries are not required except on reconnect. 0 turns off in-session retries, and is the recommended setting. Adding retries to an already overloaded network only exacerbates the problem.

## ◆ ssl

MQTTAsync_SSLOptions* ssl

This is a pointer to an MQTTAsync_SSLOptions structure. If your application does not make use of SSL, set this pointer to NULL.

## ◆ onSuccess

MQTTAsync_onSuccess* onSuccess

A pointer to a callback function to be called if the connect successfully completes. Can be set to NULL, in which case no indication of successful completion will be received.

## ◆ onFailure

MQTTAsync_onFailure* onFailure

A pointer to a callback function to be called if the connect fails. Can be set to NULL, in which case no indication of unsuccessful completion will be received.

## ◆ context

void* context

    A pointer to any application-specific context. The

the context pointer is passed to success or failure callback functions to provide access to the context information in the callback.

## ◆ serverURIcount

int serverURIcount

The number of entries in the serverURIs array.

## ◆ serverURIs

char* const* serverURIs

    An array of null-terminated strings specifying the servers to

which the client will connect. Each string takes the form protocol://host:port. protocol must be tcp, ssl, ws or wss. The TLS enabled prefixes (ssl, wss) are only valid if a TLS version of the library is linked with. For host, you can specify either an IP address or a domain name. For instance, to connect to a server running on the local machines with the default MQTT port, specify tcp://localhost:1883.

## ◆ MQTTVersion

int MQTTVersion

Sets the version of MQTT to be used on the connect. MQTTVERSION_DEFAULT (0) = default: start with 3.1.1, and if that fails, fall back to 3.1 MQTTVERSION_3_1 (3) = only try version 3.1 MQTTVERSION_3_1_1 (4) = only try version 3.1.1

## ◆ automaticReconnect

int automaticReconnect

Reconnect automatically in the case of a connection being lost. 0=false, 1=true

## ◆ minRetryInterval

int minRetryInterval

The minimum automatic reconnect retry interval in seconds. Doubled on each failed retry.

## ◆ maxRetryInterval

int maxRetryInterval

The maximum automatic reconnect retry interval in seconds. The doubling stops here on failed retries.

## ◆ len

int len

binary password length

## ◆ data

const void* data

binary password data

## ◆ [struct]

struct { ... } binarypwd

Optional binary password. Only checked and used if the password option is NULL

## ◆ cleanstart

int cleanstart

## ◆ connectProperties

MQTTProperties* connectProperties

MQTT V5 properties for connect

## ◆ willProperties

MQTTProperties* willProperties

MQTT V5 properties for the will message in the connect

## ◆ onSuccess5

MQTTAsync_onSuccess5* onSuccess5

A pointer to a callback function to be called if the connect successfully completes. Can be set to NULL, in which case no indication of successful completion will be received.

## ◆ onFailure5

MQTTAsync_onFailure5* onFailure5

A pointer to a callback function to be called if the connect fails. Can be set to NULL, in which case no indication of unsuccessful completion will be received.

## ◆ httpHeaders

const MQTTAsync_nameValue* httpHeaders

HTTP headers for websockets

## ◆ httpProxy

const char* httpProxy

The string value of the HTTP proxy. Examples:

- http://your.proxy.server:8080/
- http://user:pass@my.proxy.server:8080/

## ◆ httpsProxy

const char* httpsProxy

HTTPS proxy setting. See MQTTAsync_connectOptions.httpProxy and the section HTTP Proxies.

The documentation for this struct was generated from the following file:

- MQTTAsync.h